Index: src/java/org/jivesoftware/spark/ui/ContactList.java
===================================================================
--- src/java/org/jivesoftware/spark/ui/ContactList.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ui/ContactList.java	(working copy)
@@ -31,16 +31,16 @@
 import org.jivesoftware.spark.component.VerticalFlowLayout;
 import org.jivesoftware.spark.plugin.ContextMenuListener;
 import org.jivesoftware.spark.plugin.Plugin;
+import org.jivesoftware.spark.ui.rooms.ChatRoomImpl;
 import org.jivesoftware.spark.util.ModelUtil;
 import org.jivesoftware.spark.util.ResourceUtils;
+import org.jivesoftware.spark.util.SwingTimerTask;
 import org.jivesoftware.spark.util.TaskEngine;
 import org.jivesoftware.spark.util.log.Log;
 import org.jivesoftware.sparkimpl.profile.VCardManager;
 import org.jivesoftware.sparkimpl.settings.local.LocalPreferences;
 import org.jivesoftware.sparkimpl.settings.local.SettingsManager;
 
-import sun.util.logging.resources.logging;
-
 import javax.swing.*;
 import java.awt.*;
 import java.awt.event.ActionEvent;
@@ -215,7 +215,6 @@
                 new RosterDialog().showRosterDialog();
             }
         });
-        
     }
 
     /**
@@ -229,7 +228,6 @@
             // We ignore this.
             return;
         }
-
         final Roster roster = SparkManager.getConnection().getRoster();
 
         final String bareJID = StringUtils.parseBareAddress(presence.getFrom());
@@ -1035,7 +1033,12 @@
         }
         else if (e.getSource() == chatMenu) {
             if (activeItem != null) {
-                SparkManager.getChatManager().activateChat(activeItem.getJID(), activeItem.getDisplayName());
+            	if(!(SparkManager.getExternalizedFrame(activeItem.getAlias()) == null))
+         	  	{
+         	  		SparkManager.getExternalizedFrame(activeItem.getAlias()).setVisible(true);
+         	  	}
+            	else
+            		SparkManager.getChatManager().activateChat(activeItem.getJID(), activeItem.getDisplayName());
             }
         }
         else if (e.getSource() == addContactMenu) {
@@ -1153,19 +1156,35 @@
         activeKeyEvent = null;
     }
 
-    public void contactItemDoubleClicked(ContactItem item) {
-        activeItem = item;
-
-        ChatManager chatManager = SparkManager.getChatManager();
-        boolean handled = chatManager.fireContactItemDoubleClicked(item);
-
-        if (!handled) {
-            chatManager.activateChat(item.getJID(), item.getDisplayName());
-        }
-
-        clearSelectionList(item);
-
-        fireContactItemDoubleClicked(item);
+    public void contactItemDoubleClicked(final ContactItem item) {
+        
+   	  JFrame extFrame = SparkManager.getExternalizedFrame(item.getAlias());
+   	  if(extFrame != null)
+   	  {
+   	  	  	extFrame.setVisible(true);
+   	  		extFrame.toFront();
+   	  		extFrame.setState(Frame.NORMAL);
+   	  }
+   	  else
+   	  {
+   		  final ChatManager chatManager = SparkManager.getChatManager();
+   		  if(SettingsManager.getLocalPreferences().isTabsExternalizedOn() && !chatManager.chatRoomExists(item.getJID())) {
+		  	  		chatManager.getChatContainer().externalizeTab(new ChatRoomImpl(item.getJID(), item.getDisplayName(), item.getDisplayName()), chatManager.getChatContainer().getX(), chatManager.getChatContainer().getY(), false);
+		  	  	}
+   		   else {
+			   	activeItem = item;
+			
+			  	  	boolean handled = chatManager.fireContactItemDoubleClicked(item);
+			       
+			  	  	if (!handled) {
+			  	  		chatManager.activateChat(item.getJID(), item.getDisplayName());
+			  	  	}
+			  	  
+			  	  	clearSelectionList(item);
+		
+			  	  	fireContactItemDoubleClicked(item);
+   		   }
+   	  }
     }
 
     public void contactGroupPopup(MouseEvent e, final ContactGroup group) {
Index: src/java/org/jivesoftware/spark/ui/rooms/ChatRoomImpl.java
===================================================================
--- src/java/org/jivesoftware/spark/ui/rooms/ChatRoomImpl.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ui/rooms/ChatRoomImpl.java	(working copy)
@@ -10,6 +10,23 @@
 
 package org.jivesoftware.spark.ui.rooms;
 
+import java.awt.Color;
+import java.awt.GridBagConstraints;
+import java.awt.Insets;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.text.DateFormat;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Date;
+import java.util.List;
+import java.util.TimerTask;
+
+import javax.swing.Icon;
+import javax.swing.JComponent;
+import javax.swing.SwingUtilities;
+import javax.swing.event.DocumentEvent;
+
 import org.jivesoftware.resource.Res;
 import org.jivesoftware.resource.SparkRes;
 import org.jivesoftware.smack.Roster;
@@ -30,6 +47,7 @@
 import org.jivesoftware.spark.ChatManager;
 import org.jivesoftware.spark.PresenceManager;
 import org.jivesoftware.spark.SparkManager;
+import org.jivesoftware.spark.ui.ChatContainer;
 import org.jivesoftware.spark.ui.ChatRoom;
 import org.jivesoftware.spark.ui.ChatRoomButton;
 import org.jivesoftware.spark.ui.ContactItem;
@@ -47,19 +65,6 @@
 import org.jivesoftware.sparkimpl.settings.local.LocalPreferences;
 import org.jivesoftware.sparkimpl.settings.local.SettingsManager;
 
-import javax.swing.Icon;
-import javax.swing.SwingUtilities;
-import javax.swing.event.DocumentEvent;
-
-import java.awt.*;
-import java.awt.event.ActionEvent;
-import java.text.DateFormat;
-import java.util.ArrayList;
-import java.util.Collection;
-import java.util.Date;
-import java.util.List;
-import java.util.TimerTask;
-
 /**
  * This is the Person to Person implementation of <code>ChatRoom</code>
  * This room only allows for 1 to 1 conversations.
@@ -93,9 +98,13 @@
 
     // Information button
     private ChatRoomButton infoButton;
-
+    
     private ChatRoomButton addToRosterButton;
-
+    
+    private ChatRoomImpl me;
+    
+    private ChatRoomButton internalizeButton;
+    
     /**
      * Constructs a 1-to-1 ChatRoom.
      *
@@ -111,11 +120,12 @@
         // Loads the current history for this user.
         loadHistory();
 
+        //throw new Exception("test");
+        
         // Register PacketListeners
         PacketFilter fromFilter = new FromMatchesFilter(participantJID);
         PacketFilter orFilter = new OrFilter(new PacketTypeFilter(Presence.class), new PacketTypeFilter(Message.class));
         PacketFilter andFilter = new AndFilter(orFilter, fromFilter);
-
         SparkManager.getConnection().addPacketListener(this, andFilter);
 
         // The roomname will be the participantJID
@@ -135,15 +145,17 @@
         presence = PresenceManager.getPresence(participantJID);
 
         roster = SparkManager.getConnection().getRoster();
-
+        
         RosterEntry entry = roster.getEntry(participantJID);
 
-        tabIcon = PresenceManager.getIconFromPresence(presence);
+//      tabIcon = PresenceManager.getIconFromPresence(presence);
 
         // Create toolbar buttons.
         infoButton = new ChatRoomButton("", SparkRes.getImageIcon(SparkRes.PROFILE_IMAGE_24x24));
         infoButton.setToolTipText(Res.getString("message.view.information.about.this.user"));
 
+       
+        
         // Create basic toolbar.
         getToolBar().addChatRoomButton(infoButton);
 
@@ -266,7 +278,6 @@
         catch (Exception ex) {
             Log.error("Error sending message", ex);
         }
-
         // Before sending message, let's add our full jid for full verification
         message.setType(Message.Type.chat);
         message.setTo(participantJID);
@@ -429,7 +440,6 @@
                     if (message.getBody() != null) {
                         participantJID = message.getFrom();
                         insertMessage(message);
-
                         showTyping(false);
                     }
                 }
@@ -480,7 +490,7 @@
         if (messageEvent != null) {
             checkEvents(message.getFrom(), message.getPacketID(), messageEvent);
         }
-
+        
         getTranscriptWindow().insertMessage(participantNickname, message, ChatManager.FROM_COLOR, Color.white);
 
         // Set the participant jid to their full JID.
@@ -669,10 +679,9 @@
     // I would normally use the command pattern, but
     // have no real use when dealing with just a couple options.
     public void actionPerformed(ActionEvent e) {
-
         if (e.getSource() == infoButton) {
             VCardManager vcard = SparkManager.getVCardManager();
-            vcard.viewProfile(participantJID, SparkManager.getChatManager().getChatContainer());
+            vcard.viewProfile(participantJID, (JComponent)infoButton.getParent().getParent().getParent());
         }
         else if (e.getSource() == addToRosterButton) {
             RosterDialog rosterDialog = new RosterDialog();
@@ -683,4 +692,27 @@
             super.actionPerformed(e);
         }
     }
+
+    public void setInternalizeButton(ChatRoomButton intButton)
+    {
+   	 internalizeButton = intButton;
+	    internalizeButton.addActionListener(new ActionListener() {
+	       public void actionPerformed(ActionEvent actionEvent) 
+	       {
+	      	 ChatRoomImpl externalChatroom = (ChatRoomImpl)internalizeButton.getParent().getParent().getParent();
+	      	 SparkManager.getWorkspace().getTranscriptPlugin().chatRoomClosed(externalChatroom);
+	      	 internalizeTab(externalChatroom);
+	      	 externalChatroom.closeChatRoom();
+	       }
+	   });
+    }
+    
+    public void internalizeTab(ChatRoomImpl chatroom){
+		 SparkManager.getExternalizedFrame(chatroom.getParticipantNickname()).setVisible(false);
+ 	  	 SparkManager.getExternalizedFrame(chatroom.getParticipantNickname()).setTitle("");
+ 	  	 ChatContainer chatContainer = SparkManager.getChatManager().getChatContainer();
+ 	  	 String[] jid = chatroom.getParticipantJID().split("/spark");
+ 	  	 chatContainer.addChatRoom(new ChatRoomImpl(jid[0], chatroom.getParticipantNickname(), chatroom.getTabTitle()));
+ 	  	 chatContainer.setSelectedTab(chatContainer.getTabAt(chatContainer.indexOfTab(chatroom.getTabTitle())));
+    }
 }
Index: src/java/org/jivesoftware/sparkimpl/plugin/alerts/BuzzPlugin.java
===================================================================
--- src/java/org/jivesoftware/sparkimpl/plugin/alerts/BuzzPlugin.java	(revision 10873)
+++ src/java/org/jivesoftware/sparkimpl/plugin/alerts/BuzzPlugin.java	(working copy)
@@ -22,6 +22,7 @@
 import org.jivesoftware.spark.ui.ChatRoomListener;
 import org.jivesoftware.spark.ui.ChatRoomNotFoundException;
 import org.jivesoftware.spark.ui.ContactItem;
+import org.jivesoftware.spark.ui.ShakeWindow;
 import org.jivesoftware.spark.ui.rooms.ChatRoomImpl;
 import org.jivesoftware.spark.util.SwingTimerTask;
 import org.jivesoftware.spark.util.TaskEngine;
@@ -117,11 +118,19 @@
         }
 
         ChatFrame chatFrame = SparkManager.getChatManager().getChatContainer().getChatFrame();
-        if (chatFrame != null && chatFrame.isVisible()) {
-            chatFrame.buzz();
-            SparkManager.getChatManager().getChatContainer().activateChatRoom(room);
+        
+        if(SparkManager.getExternalizedFrame(room.getTabTitle()) != null)
+        {
+      	  chatFrame.buzz(SparkManager.getExternalizedFrame(room.getTabTitle()));
+        }
+        else
+        {
+	        if (chatFrame != null && chatFrame.isVisible()) {
+	            chatFrame.buzz(chatFrame);
+	            SparkManager.getChatManager().getChatContainer().activateChatRoom(room);
+	        }
         }
-
+        
         // Insert offline message
         room.getTranscriptWindow().insertNotificationMessage("BUZZ", ChatManager.NOTIFICATION_COLOR);
         room.scrollToBottom();
Index: src/java/org/jivesoftware/sparkimpl/plugin/emoticons/Emoticon.java
===================================================================
--- src/java/org/jivesoftware/sparkimpl/plugin/emoticons/Emoticon.java	(revision 10873)
+++ src/java/org/jivesoftware/sparkimpl/plugin/emoticons/Emoticon.java	(working copy)
@@ -11,6 +11,8 @@
 package org.jivesoftware.sparkimpl.plugin.emoticons;
 
 import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.Hashtable;
 import java.util.List;
 import java.io.File;
 
@@ -25,8 +27,10 @@
     private String emoticonName;
     private File emoticonDirectory;
     private List<String> equivalants = new ArrayList<String>();
-
-
+    private static final List<String> allEquivalants = new ArrayList<String>();
+    private static final Hashtable<String, String> equivalantsMap = new Hashtable<String, String>();
+    private static final Hashtable<String, Emoticon> emoticons 	 = new Hashtable<String, Emoticon>();
+  
     /**
      * Creates a single Emoticon entry.
      *
@@ -38,8 +42,17 @@
     public Emoticon(String nameOfImage, String emoticonName, List<String> equivalants, File emoticonDirectory) {
         this.imageName = nameOfImage;
         this.emoticonName = emoticonName;
-
         this.equivalants = equivalants;
+        
+        
+        for(String string : equivalants)
+        {
+      	  allEquivalants.add(string);
+      	  equivalantsMap.put(string, emoticonName);
+        }
+        emoticons.put(emoticonName, this);
+        
+        
         this.emoticonDirectory = emoticonDirectory;
     }
 
@@ -81,4 +94,19 @@
     public File getEmoticonDirectory(){
         return emoticonDirectory;
     }
+    
+    public static List<String> getAllEquivalants()
+    {
+   	 return allEquivalants;
+    }
+    
+    public static Emoticon getEmoticon(String key)
+    {
+   	 return emoticons.get(key);
+    }
+    
+    public static String getEmoticonname(String key)
+    {
+   	 return equivalantsMap.get(key);
+    }
 }
Index: src/java/org/jivesoftware/sparkimpl/plugin/transcripts/ChatTranscriptPlugin.java
===================================================================
--- src/java/org/jivesoftware/sparkimpl/plugin/transcripts/ChatTranscriptPlugin.java	(revision 10873)
+++ src/java/org/jivesoftware/sparkimpl/plugin/transcripts/ChatTranscriptPlugin.java	(working copy)
@@ -20,7 +20,6 @@
 import org.jivesoftware.spark.SparkManager;
 import org.jivesoftware.spark.component.BackgroundPanel;
 import org.jivesoftware.spark.plugin.ContextMenuListener;
-import org.jivesoftware.spark.ui.ChatInputEditor;
 import org.jivesoftware.spark.ui.ChatRoom;
 import org.jivesoftware.spark.ui.ChatRoomButton;
 import org.jivesoftware.spark.ui.ChatRoomClosingListener;
@@ -41,14 +40,10 @@
 import javax.swing.JDialog;
 import javax.swing.JEditorPane;
 import javax.swing.JFrame;
-import javax.swing.JLabel;
-import javax.swing.JOptionPane;
 import javax.swing.JPanel;
 import javax.swing.JPopupMenu;
 import javax.swing.JScrollPane;
 import javax.swing.JTextArea;
-import javax.swing.JTextField;
-import javax.swing.event.HyperlinkListener;
 import javax.swing.text.html.HTMLEditorKit;
 
 import java.awt.BorderLayout;
@@ -59,7 +54,6 @@
 import java.awt.event.WindowAdapter;
 import java.awt.event.WindowEvent;
 import java.io.File;
-import java.io.IOException;
 import java.text.SimpleDateFormat;
 import java.util.Comparator;
 import java.util.Date;
@@ -77,9 +71,9 @@
     private final String dateFormat = ((SimpleDateFormat)SimpleDateFormat.getDateInstance(SimpleDateFormat.FULL)).toPattern();
     private final SimpleDateFormat notificationDateFormatter;
     private final SimpleDateFormat messageDateFormatter;
-
+    private Message lastMessage;
     private JDialog Frame;
-    private JEditorPane jEditorPane1 ;
+    
     /**
      * Register the listeners for transcript persistence.
      */
@@ -173,6 +167,15 @@
                 }
             }
         }
+        
+        for (ChatRoom room : SparkManager.getExternalizedChatRooms()) {
+           if (room instanceof ChatRoomImpl) {
+               ChatRoomImpl roomImpl = (ChatRoomImpl)room;
+               if (roomImpl.isActive()) {
+                   persistChatRoom(roomImpl);
+               }
+           }
+       }
     }
 
     public boolean canShutDown() {
@@ -184,13 +187,14 @@
         if (!pref.isChatHistoryEnabled()) {
             return;
         }
-
+        
         final String jid = room.getRoomname();
+      
         File transcriptFile = ChatTranscripts.getTranscriptFile(jid);
         if (!transcriptFile.exists()) {
             return;
         }
-
+       
         if (room instanceof ChatRoomImpl) {
             new ChatRoomDecorator(room);
         }
@@ -207,7 +211,7 @@
         }
     }
 
-    private void persistChatRoom(final ChatRoom room) {
+    public void persistChatRoom(final ChatRoom room) {
         LocalPreferences pref = SettingsManager.getLocalPreferences();
         if (!pref.isChatHistoryEnabled()) {
             return;
@@ -218,6 +222,7 @@
         final List<Message> transcripts = room.getTranscripts();
         ChatTranscript transcript = new ChatTranscript();
         for (Message message : transcripts) {
+      	  	lastMessage = message;
             HistoryMessage history = new HistoryMessage();
             history.setTo(message.getTo());
             history.setFrom(message.getFrom());
@@ -233,6 +238,9 @@
         }
 
         ChatTranscripts.appendToTranscript(jid, transcript);
+
+        if(room instanceof ChatRoomImpl)
+      	  room.getTranscripts().clear();
     }
 
     public void chatRoomActivated(ChatRoom room) {
@@ -251,6 +259,11 @@
         // Do nothing.
     }
 
+    public Message getLastMessage()
+    {
+   	 return lastMessage;
+    }
+    
     private void showHistory(final String jid) {
 
         SwingWorker transcriptLoader = new SwingWorker() {
Index: src/java/org/jivesoftware/sparkimpl/preference/PreferenceDialog.java
===================================================================
--- src/java/org/jivesoftware/sparkimpl/preference/PreferenceDialog.java	(revision 10865)
+++ src/java/org/jivesoftware/sparkimpl/preference/PreferenceDialog.java	(working copy)
@@ -79,7 +79,7 @@
                 JOptionPane.OK_CANCEL_OPTION, null, options, options[0]);
         mainPanel.add(pane, BorderLayout.CENTER);
         preferenceDialog.pack();
-        preferenceDialog.setSize(700, 480);
+        preferenceDialog.setSize(700, 520);
         preferenceDialog.setContentPane(mainPanel);
         preferenceDialog.setLocationRelativeTo(SparkManager.getMainWindow());
 
Index: src/java/org/jivesoftware/sparkimpl/preference/chat/ChatPreference.java
===================================================================
--- src/java/org/jivesoftware/sparkimpl/preference/chat/ChatPreference.java	(revision 10873)
+++ src/java/org/jivesoftware/sparkimpl/preference/chat/ChatPreference.java	(working copy)
@@ -70,6 +70,7 @@
                 boolean chatHistoryHidden = !localPreferences.isChatHistoryEnabled();
                 boolean prevChatHistoryHidden = !localPreferences.isPrevChatHistoryEnabled();
                 boolean tabsOnTop = localPreferences.isTabTopPosition();
+                boolean tabsExternalized = localPreferences.isTabsExternalizedOn();
                 boolean buzzAllowed = localPreferences.isBuzzEnabled();
                 panel.setShowTime(showTime);
                 panel.setSpellCheckerOn(spellCheckerOn);
@@ -78,6 +79,7 @@
                 panel.setPrevChatHistoryHidden(prevChatHistoryHidden);
                 panel.setChatTimeoutTime(localPreferences.getChatLengthDefaultTimeout());
                 panel.setTabsOnTop(tabsOnTop);
+                panel.setTabsExternalized(tabsExternalized);
                 panel.setBuzzEnabled(buzzAllowed);
             }
         };
@@ -99,6 +101,7 @@
         pref.setPrevChatHistoryEnabled(!panel.isPrevChatHistoryHidden());
         pref.setChatLengthDefaultTimeout(panel.getChatTimeoutTime());
         pref.setTabsOnTop(panel.isTabsOnTop());
+        pref.setTabsExternalized(panel.isTabsExternalizeOn());
         pref.setBuzzEnabled(panel.isBuzzEnabled());
 
         SettingsManager.saveSettings();
Index: src/java/org/jivesoftware/sparkimpl/preference/chat/ChatPreferencePanel.java
===================================================================
--- src/java/org/jivesoftware/sparkimpl/preference/chat/ChatPreferencePanel.java	(revision 10873)
+++ src/java/org/jivesoftware/sparkimpl/preference/chat/ChatPreferencePanel.java	(working copy)
@@ -58,6 +58,7 @@
     private JCheckBox hideChatHistory = new JCheckBox();
     private JCheckBox hidePrevChatHistory = new JCheckBox();
     private JCheckBox tabsOnTopBox = new JCheckBox();
+    private JCheckBox tabsExternalize = new JCheckBox();
     private JTextField chatTimeoutField = new JTextField();
     private JCheckBox buzzBox = new JCheckBox();
 
@@ -91,6 +92,7 @@
         ResourceUtils.resButton(hideChatHistory, Res.getString("checkbox.disable.chat.history"));
         ResourceUtils.resButton(hidePrevChatHistory, Res.getString("checkbox.disable.prev.chat.history"));
         ResourceUtils.resButton(tabsOnTopBox, Res.getString("checkbox.tabs.on.top"));
+        ResourceUtils.resButton(tabsExternalize, Res.getString("checkbox.tabs.externalize"));
         ResourceUtils.resButton(buzzBox, Res.getString("checkbox.allow.buzz"));
 
         generalPanel.setBorder(BorderFactory.createTitledBorder(Res.getString("group.general.information")));
@@ -113,12 +115,13 @@
         chatWindowPanel.add(hideChatHistory, new GridBagConstraints(0, 3, 2, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
         chatWindowPanel.add(hidePrevChatHistory, new GridBagConstraints(0, 4, 2, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
         chatWindowPanel.add(tabsOnTopBox, new GridBagConstraints(0, 5, 2, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
-        chatWindowPanel.add(buzzBox, new GridBagConstraints(0, 6, 2, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
+        chatWindowPanel.add(tabsExternalize, new GridBagConstraints(0, 6, 2, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
+        chatWindowPanel.add(buzzBox, new GridBagConstraints(0, 7, 2, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        
         JLabel chatTimeoutLabel = new JLabel();
         ResourceUtils.resLabel(chatTimeoutLabel, chatTimeoutField, Res.getString("label.minutes.before.stale.chat") + ":");
-        chatWindowPanel.add(chatTimeoutLabel, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
-        chatWindowPanel.add(chatTimeoutField, new GridBagConstraints(1, 7, 2, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 50, 0));
+        chatWindowPanel.add(chatTimeoutLabel, new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
+        chatWindowPanel.add(chatTimeoutField, new GridBagConstraints(1, 8, 2, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 50, 0));
 
 
         generalPanel.add(passwordLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
@@ -236,6 +239,14 @@
     public boolean isTabsOnTop(){
         return tabsOnTopBox.isSelected();
     }
+    
+    public void setTabsExternalized(boolean externalized) {
+       tabsExternalize.setSelected(externalized);
+    }
+    
+    public boolean isTabsExternalizeOn(){
+       return tabsExternalize.isSelected();
+    }
 
     public void setBuzzEnabled(boolean allowBuzz){
         buzzBox.setSelected(allowBuzz);
Index: src/java/org/jivesoftware/sparkimpl/settings/local/LocalPreferences.java
===================================================================
--- src/java/org/jivesoftware/sparkimpl/settings/local/LocalPreferences.java	(revision 10873)
+++ src/java/org/jivesoftware/sparkimpl/settings/local/LocalPreferences.java	(working copy)
@@ -547,6 +547,14 @@
         return getBoolean("tabsOnTop", true);
     }
 
+    public void setTabsExternalized(boolean externalized) {
+   	 setBoolean("tabsExternalized", externalized);
+    }
+    
+    public boolean isTabsExternalizedOn() {
+   	 return getBoolean("tabsExternalized", false);
+    }
+    
     public void setBuzzEnabled(boolean enabled) {
         setBoolean("buzzEnabled", enabled);
     }
